0%

挑战leetcode前50道

1. 两数之和

给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那 两个 整数,并返回它们的数组下标。

你可以假设每种输入只会对应一个答案,并且你不能使用两次相同的元素。

你可以按任意顺序返回答案。

示例 1:

1
2
3
输入:nums = [2,7,11,15], target = 9
输出:[0,1]
解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。

示例 2:

1
2
输入:nums = [3,2,4], target = 6
输出:[1,2]

示例 3:

1
2
输入:nums = [3,3], target = 6
输出:[0,1]

提示:

  • 2 <= nums.length <= 104
  • -109 <= nums[i] <= 109
  • -109 <= target <= 109
  • 只会存在一个有效答案

进阶:你可以想出一个时间复杂度小于 O(n2) 的算法吗?

思路

简单直观的思路是,两轮循环,暴力枚举所有可能的组合,相加判断是否等于目标值,但是题目要求时间复杂度小于 O(n2),因此这种 方法不行。换一种思路一次遍历值为x,如何在o(1)时间复杂度寻找target-x,使用哈希表可以做到,使用空间换时间,时间复杂度为O(n),空间复杂度也为O(n)。

解法:

1
2
3
4
5
6
7
8
9
10
11
12
13
class Solution {
public int[] twoSum(int[] nums, int target) {
HashMap<Integer, Integer> hashMap = new HashMap<Integer, Integer>();
for (int i = 0; i < nums.length; i++) {
if (!hashMap.containsKey(target - nums[i])) {
hashMap.put(nums[i], i);
} else {
return new int[]{hashMap.get(target - nums[i]), i};
}
}
return new int[]{};
}
}